//Leveling file completly rewritten for BETA4 by Levis and Pieter Boelen

//Initialize some stuff
int AllDaysCount;//MAXIMUS: calculates days amount (updating in calendar.c)
bool PostInitActive = false;
object PostInitQueue;
object SkillBonus;

#event_handler("PostInitChars","PostInitChars");

#define DEBUG_EXPERIENCE	0					//(int) on 0 no messages are given. on 1 only error, on 2 everything is given.
#define DEBUG_POSTINIT		0					//(int) on 0 no messages are given. on 1 only error, on 2 everything is given.
#define DEBUG_NOAUTOLEVEL	0					//(int) on 0 no messages are given. on 1 only error, on 2 everything is given.
#define DEBUG_PERKSELECT	0					//(int) on 0 no messages are given. on 1 only error, on 2 everything is given.

#define XP_GROUP_PLAYER		"player"			//(DO NOT CHANGE) XP will only be given to the player
#define XP_GROUP_OFFIC		"officers"			//(DO NOT CHANGE) XP will be given to player and officers
#define XP_GROUP_PARTY		"party"				//(DO NOT CHANGE) XP will be given to everyone in the party

#define SKILLS_UP_BONUS			25				// From 10 to 99 - speed of player's skills-increase
#define SKILL_EXPERIENCE_MULTIPLIER	1.0			// FLOAT - Must be a float higher than 0.0 - default is 1.0 - the rate at which the characters gain skill experience: For a 30% increase set to 1.3
#define EXPERIENCE_MULTIPLIER	1.0				// FLOAT - Must be a float higher than 0.0 - default is 1.0 - the rate at which the characters gain experience: For a 30% increase set to 1.3

#define	XP_PERCENTAGE_SHARED	0.20			// FLOAT - percentage which is shared by shared experience
#define	XP_GAIN_OFFIC_ACTIVE	1.00			// FLOAT - percentage which active officer get when XP to all
#define	XP_GAIN_OFFIC_INACTIVE	0.40			// FLOAT - percentage which officer get when XP to all
#define XP_GAIN_COMPANION		0.60			// FLOAT - percentage which companion get when XP to all

#define ADD_SKILLPOINTS_PERLEVEL		2		// INT - The amount of new skill points added each level up for ALL characters (player and officers)
#define ADD_ABILITYPOINTS_PERLEVEL		1		// INT - The amount of new ability points added each level up for ALL characters (player and officers)

#define IMPORTANCE_BONUS_GAIN			25		// INT - The multiplier for the importance if a bonus is present for this skill
#define IMPORTANCE_SKILL_GAIN			30		// INT - The multiplier for each level the character has already in this skill
#define IMPORTANCE_BOOST				40		// INT - The multiplier for the importance set in officers.c

#define NPC_ONE_BONUS_CHANCE			60		// INT - The chance an NPC will have only 1 bonus skill
#define NPC_TWO_BONUS_CHANCE			30		// INT - The chance an NPC will have 2 bonus skills. If one and two aren't 100 together, there is a chance the NPC has no bonus skills.

#define	POSTINIT_AMOUNT_PIECES			3		// INT - Divde the XP given to a character on a post init run by this. Make this higher to increase amount of FPS at load, but longer post init
#define POSTINIT_AMOUNT_LEVELS			1		// INT - Amount of levels done simultaniously on post init. Higher is lower post init time but also lower FPS on load
#define POSTINIT_MAX_ALLOW_LEVEL_POST	40		// INT - Characters higher then this level wont be going trough post init, lower this to get shorter post init but longer loading times

//=====================================================
//  MAIN FUNCTION
//=====================================================

//This function is called each character load
void InitAutoSkillsSystem(ref refCharacter, bool dailyUpdate)
{
	if(!IsMainCharacter(refCharacter) && !sti(refCharacter.index)==GetMainCharacterIndex() && !bAllies(refCharacter))
	{
		if(DEBUG_EXPERIENCE>1 || DEBUG_POSTINIT>1 || DEBUG_NOAUTOLEVEL > 1) Trace("XP LOG: Start InitAutoSkillsSystem for "+GetMySimpleName(refCharacter)+" id: "+refCharacter.id);
		if (CheckAttribute(refCharacter,"corpse")) return;
		if (!CheckAttribute(refCharacter,"completeinit")) 
		{
			if(DEBUG_EXPERIENCE>1 || DEBUG_POSTINIT>1) Trace("Need to init skills");
			InitCharacterSkills(refCharacter);
			return;
		}
		/*if (!CheckAttribute(refCharacter,"Experience")) refCharacter.Experience = 1;
		if (!CheckAttribute(refCharacter,"rank")) refCharacter.rank = 1;*/ //Should be fixed by InitChracter Already
		//int nextSkill = 50000;
		//int skillsCalc = 0;
		//if(SKILLS_UP_BONUS<10) SKILLS_UP_BONUS = 10;
		//if(SKILLS_UP_BONUS>99) SKILLS_UP_BONUS = 99;
		if(dailyUpdate && AUTO_SKILL_SYSTEM)
		{
			float curSpeed = makefloat(stf(SKILLS_UP_BONUS+100)/100);
			int numUp = sti(GetDataYear() + GetDataMonth() + AllDaysCount);
			int expUp = sti(GetDifficulty()*500);
			if (CheckAttribute(refCharacter,"locDate") && numUp - sti(refCharacter.locDate) > 0) {
				numUp = sti(numUp - sti(refCharacter.locDate));
				expUp = expUp*numUp;
			} else {
				expUp = 0;
			}
			//Levis: The rest will now all be handled by the addxp function.
			AddXP(refCharacter, "", expUp, XP_GROUP_PLAYER);
			refCharacter.locDate = sti(GetDataYear() + GetDataMonth() + AllDaysCount);
		}
	}
	else
	{
		if(!CheckAttribute(refCharacter,"completeinit")) refCharacter.completeinit = true;
	}
}

//=====================================================
//  Adding XP functions
//=====================================================

//This function is always called. it determins who should get the XP etc
bool AddXP(ref chref, string expName, int _exp, string group)
{
	bool LevelUp = false;
	//First catch some weird cases which shouldn't happen in the first place. let log if they do happen.
	if(!CheckAttribute(chref,"index")) { return false; if(DEBUG_EXPERIENCE>0) Trace("XP ERROR: Character "+GetMySimpleName(chref)+" has no index");}
	if(sti(chref.index)<0) { return false; if(DEBUG_EXPERIENCE>0){ Trace("XP ERROR: Character "+GetMySimpleName(chref)+" has index smaller than 0");} }
	if(_exp <= 0) 
	{ 
		_exp = -(_exp); 
		if(DEBUG_EXPERIENCE>0) { Trace("XP ERROR: NEGATIVE OR ZERO XP");} 
	}
	if(_exp == 0) return false;
	
	//Check for shared experience
	bool SharedXP = GetOfficersPerkUsing(chref,"SharedExperience");
	
	if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Called AddXP for "+GetMySimpleName(chref)+" with skill: "+expName+" and xp: "+_exp+" and group: "+group);
	if(DEBUG_EXPERIENCE>1) { if(SharedXP) Trace("XP LOG: SharedXP is active"); }
	
	//Add a difficulty multiplier
	float diffmult = 1.0-((GetDifficulty()-1.0) / 6.0); //Let's make it a bit less dependent on difficulty

	//First handle the character which gets the XP
	float xpmult = GetXPmult(expName);
	int xp = makeint(makefloat(_exp)*xpmult);
	if(AddXPtoChar(chref, expName, makeint(diffmult*xp))) LevelUp = true;
	
	//Now handle the officers
	int cn;
	if(SharedXP || group == XP_GROUP_OFFIC || group == XP_GROUP_PARTY)
	{
		if(FindCaptainIndex(chref) >= 0)
		{
			//If this character is part of a party we want to have the whole party.
			ref captain = GetCharacter(FindCaptainIndex(chref));
			if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Checking officers for captain "+GetMySimpleName(captain));
			//Check if the captain has got the XP already
			if(captain.index != chref.index)
			{
				xpmult = XP_GAIN_OFFIC_ACTIVE;
				if(SharedXP) xpmult += XP_PERCENTAGE_SHARED;
				xp = makeint(_exp*xpmult);
				if(AddXPtoChar(captain, expName, makeint(diffmult*xp))) LevelUp = true;
			}
			if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Start checking officers");
			for(int i=0; i < GetPassengersQuantity(captain); i++)
			{
				cn = GetPassenger(chref, i);
				//Filter the original character and prisoned characters
				if(cn < 0 || cn == chref.index) continue;
				if(CheckAttribute(Characters[cn],"prisoned") && sti(Characters[cn].prisoned)) continue;
				//Set the percentage of xp given.
				xpmult = 0;
				if(SharedXP) xpmult = XP_PERCENTAGE_SHARED;
				if(group == XP_GROUP_OFFIC)
				{
					if (IsOfficer(Characters[cn]))
					{
						xpmult += XP_GAIN_OFFIC_ACTIVE;
					}
					else
					{
						xpmult += XP_GAIN_OFFIC_INACTIVE;
					}
				}
				xp = makeint(_exp*xpmult);
				//Add the experience
				if(AddXPtoChar(&Characters[cn], expName, makeint(diffmult*xp))) LevelUp = true;
			}
		}
	}
	
	//Now handle the companions
	if(SharedXP || group == XP_GROUP_PARTY)
	{
		if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Checking companions");
		if(GetCompanionQuantity(chref) > 1)
		{
			for(i=1; i < 4; i++)
			{
				cn = GetCompanionIndex(chref, i);
				//Filter the original character and prisoned characters
				if(cn < 0 || cn == chref.index) continue;
				if(CheckAttribute(Characters[cn],"prisoned") && sti(Characters[cn].prisoned)) continue;
				//Set the percentage of xp given.
				xpmult = 0;
				if(SharedXP) xpmult = XP_PERCENTAGE_SHARED;
				if(group == XP_GROUP_PARTY) xpmult += XP_GAIN_COMPANION;
				xp = makeint(_exp*xpmult);
				//The companion might have officers also so call self to manage this but with less XP already.
				if(AddXP(&Characters[cn], expName, xp, XP_GROUP_OFFIC)) LevelUp = true;;
			}
		}
	}
	//returns true if there is a levelup somewhere
	return LevelUp;
}

//Handle for a single character
bool AddXPtoChar(ref chref, string expName, int _exp)
{
	bool LevelUp = false;
	
	//In case the officertype is changed, we should apply the importances again
//	if(!CheckAttribute(chref,"skillsetup")) InitCharacterSkills(chref); //shouldn't happen but does seem to happen sometimes
	if(!CheckAttribute(chref,"skillsetup") || chref.skillsetup != chref.quest.officerType) // PB: This function can be called FROM InitCharacterSkills, so the above line could trigger an infinite loop
	{
		if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Offictype for "+GetMySimpleName(chref)+" is set or changed so (re)apply the importances.");
		SetCharSkillImportance(chref,1);
	}
	
	int realExp = _exp;
	int officerprice = 0;
	string eventname = "";

	if(DEBUG_EXPERIENCE>0) Trace("XP LOG: Called AddXPtoChar for "+GetMySimpleName(chref)+" with skill: "+expName+" and xp: "+realExp+ " CurXP: "+chref.Experience);
	
	if(CheckAttribute(chref,"completeinit"))
	{
		//We need to check the officerprice before the level is increased. Since the last update maybe the assignment or skill levels have been changed.
		officerprice = GetBaseOfficerPrice(chref);
	}
	
	//First add the skillxp so we can use the increase for perk assignment when needed.
	//If we are using the auto skill system let's assign the skill points:
	if(AUTO_SKILL_SYSTEM)
	{
		if(PostInitActive)
		{
			eventname = "AddXPtoSkills"+chref.id+chref.Experience;
			SetEventHandler(eventname,"procAddXPtoSkillsMain",1);
			PostEvent(eventname,0,"isls",chref,expName,realExp,chref.location);
		}
		else
		{
			AddXPtoSkillsMain(chref, expName, realExp);
		}
	}
	
	//Now add the overal experience
	//Add the experience to the character.

	int nextExp = CalculateExperienceFromRank(sti(chref.rank)+1);
	int curExp = sti(chref.Experience) + realExp;
	float mhp = 0;
	int n = 0;
	string skill = "freeskill";

	chref.Experience = curExp;
	
	//Check if we go level up
	//bool firstlevelup = true;
	while (curExp >= nextExp)
	{
		//Increase the rank of the character
		chref.rank = sti(chref.rank) + 1;
		//Calculate new nextExp
		nextExp = CalculateExperienceFromRank(sti(chref.rank)+1);
		//Set return value
		LevelUp = true;
		//Add freepoints for perks
		chref.perks.FreePoints = makeint(chref.perks.FreePoints) + ADD_ABILITYPOINTS_PERLEVEL;
		if(CheckAttribute(chref,"completeinit"))
		{
			//Freepoints for skills
			if(!AUTO_SKILL_SYSTEM) 
			{
				if(bAllies(chref))
				{
					chref.skill.freeskill = sti(chref.skill.freeskill) + ADD_SKILLPOINTS_PERLEVEL;
				}
				else
				{
					for(n = 0; n < ADD_SKILLPOINTS_PERLEVEL; n++)
					{
						skill = PickSkillNoAutoLevel(chref);
						chref.skill.(skill) = sti(chref.skill.(skill)) + 1;
					}
				}
			}
			string LevelText = "";
			//Display the levelup
			if(IsInParty(GetMainCharacterIndex(), sti(chref.index)))
			{
				if(CheckAttribute(chref,"FakeLevelUp"))
				{
					LevelText = TranslateString("","Fake Level Up") + " for " + GetMySimpleName(chref) + "!" + " " + TranslateString("","(Now level") + " " + chref.rank + ")";
				}
				else
				{
					LevelText = GetMySimpleName(chref) + " " + TranslateString("","has gained a new level!") + " " + TranslateString("","(Now level") + " " + GetTotalRank(chref) + ")");
					PlayStereoSound("interface\new_level.wav");
					AddMsgToCharacter(chref,MSGICON_LEVELUP);
				}
				LogIt(LevelText);
			}
			else
			{
				LevelText = GetMySimpleName(chref) + " " + TranslateString("","has gained a new level!") + " " + TranslateString("","(Now level") + " " + GetTotalRank(chref) + ")");
				//This character has noone to choose his perks so we must do it for him.
				if(!CheckAttribute(chref,"PerkTypes")) PrepareSelectPerksForCharacter(chref);
				SelectPerksForCharacter(chref, 2);
			}
			// LDH 01May09
			if(DEBUG_EXPERIENCE>0) Trace(LevelText);
		}
		else
		{
			//Pick Perks
			if(!CheckAttribute(chref,"PerkTypes")) PrepareSelectPerksForCharacter(chref);
			if(PostInitActive)
			{
				eventname = "SelectPerks"+chref.id+chref.rank;
				SetEventHandler(eventname,"procSelectPerksForCharacter",1);
				PostEvent(eventname,0,"ils",chref,1,chref.location);
			}
			else
			{
				SelectPerksForCharacter(chref, rand(1));
			}
			if(!AUTO_SKILL_SYSTEM)
			{
				//initializing without autolevel
				for(n = 0; n < ADD_SKILLPOINTS_PERLEVEL; n++)
				{
					skill = PickSkillNoAutoLevel(chref);
					if(DEBUG_NOAUTOLEVEL > 1) trace("Picked "+skill+" freeskill "+chref.skill.freeskill);
					chref.skill.(skill) = sti(chref.skill.(skill)) + 1;
				}
			}
		}
	}
	//Now we check how much the officer price would have increased and we add this to the already existing officerprice
	officerprice = GetBaseOfficerPrice(chref) - officerprice;
	if(officerprice > 0) //We'll never lower the officerprice
	{
		chref.quest.OfficerPrice = sti(chref.quest.OfficerPrice) + officerprice;
		//If there is an old officerprice, we raise this too in case it is put back
		if(CheckAttribute(chref,"quest.officerprice.old")) chref.quest.officerprice.old = sti(chref.quest.officerprice.old) + officerprice;
	}
	//Set new HP
	if(LevelUp)
	{
		if(CheckAttribute(chref,"FakeLevelUp"))
		{
			//Because the resethp takes the fake levels in account already we need to remove them here.
			if(!CheckAttribute(chref,"FakeLevels")) chref.FakeLevels = 0; //Levis
			int oldrank = sti(chref.rank);
			chref.rank = sti(chref.rank) - sti(chref.FakeLevels);
			chref.rank = oldrank;
		}
		if(CheckAttribute(chref,"completeinit")) ResetMaxHP(chref);
	}
	//DeleteAttribute(chref,"PerkTypes");
	return LevelUp;
}

//Add XP to all skills
bool AddXPtoSkillsMain(ref chref, string expName, int skillExp)
{
	if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Called AddXPtoSkillsMain with Exp: "+skillExp);
	//If there is an expname we only add it to that specific skill
	if(expName != "") return AddXPtoSkill(chref, expName, skillExp);
	bool LevelUp = false;
	if(skillExp < 1) return LevelUp;
	//Start the loop
	aref skills; makearef(skills,chref.skill);
	string skill;
	int numskills = GetAttributesNum(skills);
	int importance = 0;
	float importance_total = stf(chref.skillimportancetotal);
	float mult;
	float xp = 0;
	for(int n = 0; n < numskills; n++)
	{
		skill = GetAttributeName(GetAttributeN(skills, n));
		if(skill == "freeskill") continue;
		importance = sti(chref.skill.(skill).importance);
		//We got a total amount of XP to spend. We divide this over the different skills based on the importance of the skill
		if (importance_total > 0.0) mult = makefloat(importance) / importance_total;
		else						mult = 0.0;
		xp = makefloat(skillExp) * mult;
		if(xp < 1) continue;
		if(AddXPtoSkill(chref, skill, makeint(xp))) LevelUp = true;
	}
	return LevelUp;
}

//Adding XP to a skill
bool AddXPtoSkill(ref chref, string expName, int skillExp)
{
	bool LevelUp = false;
	//if(skillExp < 1) return LevelUp;
	
	//Check if the modified skilllevel is zero. if so we don't add experience to it.
	//If the modified skilllevel is max we should skip this function too because we dont want the importance to be set to zero just yet
	int modval = GetCharacterSkill(chref, expName);
	if(modval == 0) return LevelUp;
	
	//If the importance is set to 0 we skip this skill also
	if(sti(chref.skill.(expName).importance) == 0) return LevelUp;
	
	int chrSkillExp = sti(chref.Experience.(expName));
	
	//Add the bonus to the experience
	if (CheckAttribute(chref,"skill."+expName+".bonus")) skillExp = makeint(skillExp * stf(chref.skill.(expName).bonus));
	
	// Add the multiplier
	skillExp = makeint(skillExp * SKILL_EXPERIENCE_MULTIPLIER);

	// Add to currSkill
	int curSkill = chrSkillExp + skillExp;
	
	if(DEBUG_EXPERIENCE>1) Trace("XP LOG: AddXP to skill: "+expName+" Old Skill Exp: "+chrSkillExp+" increase with: "+makeint(skillExp) +" needed for next level: "+CalculateSkillExperienceFromRank(sti(chref.skill.(expName))+1));

	int nextSkill = CalculateSkillExperienceFromRank(sti(chref.skill.(expName))+1);
	while (curSkill >= nextSkill)
	{
		LevelUp = true;
		//Substract the xp needed to level up.
		curSkill = curSkill-nextSkill;
		//Add the level
		if(GetCharacterSkill(chref, expName) >= SKILL_MAX)
		{
			//We don't need any more XP on this skill
			if(sti(chref.skill.(expName).importance) > 0)
			{
				chref.skillimportancetotal = sti(chref.skillimportancetotal) - sti(chref.skill.(expName).importance);
				chref.skill.(expName).importance = 0;
				if(DEBUG_EXPERIENCE>1) Trace("Importance for "+expName+" is set to 0 because skill is maxed out");
			}
			//If there is a skill charmod bonus we negate this one now.
			if(GetCharacterCharMod(chref,expName) > 0)
			{
				ResetSkillCharMod(chref,expName);
				chref.skill.(expName) = SKILL_MAX;
			}
		}
		else
		{
			//Check if there is a negative charmod. If so we change that one first.
			if(GetCharacterCharMod(chref,expName) < 0)
			{
				chref.skill.(expName).charmod = GetCharacterCharMod(chref,expName) + 1;
			}
			else
			{
				chref.skill.(expName) = sti(chref.skill.(expName)) + 1;
			}
			if(CheckAttribute(chref,"completeinit"))
			{
				if (iRealismMode == 0 && LogsToggle >= LOG_NORMAL && IsInParty(GetMainCharacterIndex(), sti(chref.index))) { // KK
					Log_SetStringToLog(GetMySimpleName(chref) + " " + TranslateString("","Gained") + " " + XI_ConvertString("skill_level") + " " + XI_ConvertString(expName) + " - " + sti(chref.skill.(expName)));
				}
			}
		}
		//Calculate next needed skill exp
		nextSkill = CalculateSkillExperienceFromRank(sti(chref.skill.(expName))+1);
		if(CheckAttribute(chref,"completeinit")) ResetEffectiveSkill(chref, expName); // PB: Update effective skills because actual number changed
	}
	//Change amount of xp on char
	chref.Experience.(expName) = curSkill;
	//If we have a specific skill increase we should call the update importance function
	UpdateSkillImportance(chref, expName, skillExp);
	return LevelUp;
}

//Old XP functions, now all redirect to the new one

int AddCharacterExpChar(ref chref, string expName, int _exp) { return makeint(AddXP(chref, expName, _exp, XP_GROUP_OFFIC)); }
int AddCharacterExp(ref chref,int _exp) { return makeint(AddXP(chref, "", _exp, XP_GROUP_OFFIC)); }
void Ship_AddCharacterExpChar(ref rCharacter, string expName, int iExpQuantity) { AddXP(rCharacter, expName, iExpQuantity, XP_GROUP_OFFIC); }
int AddCharacterExpNSChar(ref chref, string expName, int _exp) { return makeint(AddXP(chref, expName, _exp, XP_GROUP_PLAYER)); }
int AddCharacterExpNS(ref chref,int _exp) { return makeint(AddXP(chref, "", _exp, XP_GROUP_PLAYER)); }
void AddPartyExpChar(ref chref, string expName, int _exp) { AddXP(chref, expName, _exp, XP_GROUP_PARTY); }
void AddPartyExp(ref chref, int _exp) { AddXP(chref, "", _exp, XP_GROUP_PARTY); }
void AddExpAndShow(ref chref, int _exp)
{
	AddXP(chref, "", _exp, XP_GROUP_PLAYER);
	Log_SetStringToLog("+" + _exp + XI_ConvertString("add experience"));
}

//=====================================================
//  Skill Functions
//=====================================================

string PickSkillNoAutoLevel(ref chref)
{
	aref skills; makearef(skills,chref.skill);
	string skill;
	int numskills = GetAttributesNum(skills);
	int importance = 0;
	float importance_total = stf(chref.skillimportancetotal);
	if(importance_total < 1) return "freeskill";
	int PickVal = rand(makeint(importance_total));
	for(int n = 0; n < numskills; n++)
	{
		skill = GetAttributeName(GetAttributeN(skills, n));
		if(skill == "freeskill") continue;
		importance = sti(chref.skill.(skill).importance);
		if(PickVal <= importance)
		{
			if(sti(chref.skill.(skill)) >= SKILL_MAX)
			{
				chref.skillimportancetotal = sti(chref.skillimportancetotal) - sti(chref.skill.(skill).importance);
				chref.skill.(skill).importance = 0;
				if(DEBUG_NOAUTOLEVEL > 1) Trace("Importance for "+skill+" is set to 0 because skill is maxed out");
				return PickSkillNoAutoLevel(chref);
			}
			else
			{
				return skill;
			}
		}
		else
		{
			PickVal = PickVal - importance;
		}
	}
	//if all fails return the last one because it means the rand value was to higher
	Trace("XP ERROR: Overflow in PickSkillNoAUtoLevel");
	return skill;
}

// Simple personal skill, only including personal modifications
int GetCharacterSkill(ref character, string skillName)
{
	int skillPoints = GetCharacterBaseSkill(character, skillName);
	//Levis add a character based modifier also
	skillPoints += GetCharacterCharMod(character, skillName);
	skillPoints = iclamp(0, SKILL_MAX, skillPoints);
	return skillPoints;
}

int GetCharacterBaseSkill(ref character, string skillName)
{
	int skillPoints = 0;
	if(CheckAttribute(character, "Skill." + skillName))
	{
		skillPoints = sti(character.Skill.(skillName));
	}
	return skillPoints;
}

int GetCharacterCharMod(ref character, string skillName)
{
	if(CheckAttribute(character,"skill."+skillName+".charmod"))
	{
		return sti(character.skill.(skillName).charmod);
	}
	else
	{
		return CalcCharacterCharMod(character, skillName);
	}
}

//Call this function for a specific skill to give it a bonus or penalty.
void SetSkillCharMod(ref character, string skillName, int offset)
{
	int baselevel = GetCharacterBaseSkill(character, skillName);
	int charmod = GetCharacterCharMod(character, skillName);
	if((baselevel + (offset + charmod)) < 1) return; //We don't want the level do drop below 1. This can only happen during the init
	if((baselevel + (offset + charmod)) > SKILL_MAX)
	{
		offset = (SKILL_MAX - baselevel);
		character.skill.(skillName).charmod = offset;
		ResetShipSkill(character, skillName); //Just to be sure
		AddXPtoSkill(character, skillName, 0);
		return;
	}
	if(baselevel == SKILL_MAX)
	{
		if(offset < 0)
		{
			int totalimportance = sti(character.skillimportancetotal);
			int inc = makeint(totalimportance * 0.1);
			if(inc < 1) inc = 100;
			character.skill.(skillName).importance = inc; //10% of importance
			character.skillimportancetotal = sti(character.skillimportancetotal) + inc;
		}
		else
		{
			return;
		}
		
	}
	charmod = charmod + offset;
	character.skill.(skillName).charmod = charmod;
	ResetShipSkill(character, skillName); //Just to be sure
}

//This will remove any charmod from the character
void ResetSkillCharMod(ref character, string skillName)
{
	character.skill.(skillName).charmod = 0;
	ResetShipSkill(character, skillName); //Just to be sure
}

int CalcCharacterCharMod(ref character, string skillName)
{
	return 0;
}

// Reset effective skills
// Called on gaining a skill point in AddXPtoSkill AND when GetEffectiveSkill detects officer type has been changed
void ResetEffectiveSkill(ref character, string skillName)
{
	DeleteAttribute(character, "skill." + skillName + ".effective");
	ResetPartySkill(character, skillName);
}

void ResetEffectiveSkillAll(ref character)
{
	for(int i = 0; i < 10; i++)
	{
		if(DEBUG_EXPERIENCE>1) trace("XP LOG: Reset effective skill "+GetSkillName(i));
		ResetEffectiveSkill(character, GetSkillName(i));
	}
}

// Reset ONLY party skills
// Called when officer is added by AddPassenger or removed by RemovePassenger
void ResetPartySkill(ref character, string skillName)
{
	DeleteAttribute(character, "skill." + skillName + ".party");
	int idx = FindCaptainIndex(character);
	if(idx >= 0)
	{
		//If this character is part of a party we want to have the whole party.
		ref captain = GetCharacter(idx);
		DeleteAttribute(captain, "skill." + skillName + ".party");
	}
	ResetShipSkill(character, skillName);
}

// Reset ship skills
// Called when GetShipSkill detects ship class or fleet size has changed
void ResetShipSkill(ref character, string skillName)
{
	DeleteAttribute(character, "skill." + skillName + ".ship");
	int idx = FindCaptainIndex(character);
	if(idx >= 0)
	{
		// The ship skills are stored with the captain, not the officer
		ref captain = GetCharacter(idx);
		DeleteAttribute(captain, "skill." + skillName + ".ship");
	}
}

// Total personal skill, including item modifiers
int CalcCharacterSkill(ref character, string skillName)
{
	int skillPoints = GetCharacterSkill(character, skillName)
	if(!CheckAttribute(character, "Skill." + skillName + ".modifier"))
	{
		skillPoints += CalcSkillModifier(character, skillName);
	}
	else
	{
		skillPoints += sti(character.Skill.(skillName).modifier);
	}
	skillPoints = iclamp(0, SKILL_MAX, skillPoints);
	return skillPoints;
}

// Effective personal skill, based on officer type
int GetEffectiveSkill(ref character, string skillName)
{
	if (GetAttribute(character,"skill."+skillName+".officertype") != GetAttribute(character,"quest.officerType")) // Levis: Detect this has changed and update accordingly
	{
		ResetEffectiveSkill(character, skillName);
	}

	int skillPoints = 0;
	if (CheckAttribute(character, "Skill." + skillName + ".effective"))
	{
		skillPoints = sti(character.Skill.(skillName).effective);
	}
	else
	{
		skillPoints = CalcEffectiveSkill(character, skillName);
	}
	return skillPoints;
}

int CalcEffectiveSkill(ref character, string skillName)
{
	int skillPoints = CalcCharacterSkill(character, skillName);
	skillPoints = GetEffectiveSkillByValue(character, skillName, skillPoints);
	character.Skill.(skillName).effective   = skillPoints;
	character.skill.(skillName).officertype = GetAttribute(character,"quest.officerType"); // Levis: we also store for which officertype this is set, so when it's changed we know to change the mod too
	return skillPoints;
}

int GetEffectiveSkillByValue(ref character, string skillName, int skillPoints)
{
	if(IsCompanion(character) || skillName == SKILL_FENCING) // PB: Perhaps treat ALL captains equally by adding CharacterHasShip?
	{
		return skillPoints;
	}

	if(CheckAttribute(character, "quest.officerType"))
	{
		int skillFactor;
		string officType = character.quest.officerType;
		if(CheckAttribute(OfficerTypes, officType))
		{
			if(!CheckAttribute(OfficerTypes,officType+".skills"))
			{
				trace("ERROR: missing skills for "+officType+" for Character "+GetMySimpleName(character)); 
				DumpAttributes(Character);
				character.quest.officerType = GetRandomEnemyType();
				officType = character.quest.officerType;
			}
			skillFactor = sti(OfficerTypes.(officType).skills.(skillName)); // KK
		}
		else
			skillFactor = 2;
		// factor: can be 0, 1, 2:
		// 1: half contribution
		// 2: full contribution
		
		// calculate result = points * factor / 2
		// two variants: floor(result) or ceil(result)
		
		// this one corresponds to floor(result)
		// return skillPoints * skillFactor / 2;
		
		// this one corresponds to ceil(result)
		return (skillPoints * skillFactor + 1) / 2;
	}
	
	return 0;
}

int GetPartySkill(ref character, string skillName)
{
	int skillPoints = 0;
	if (CheckAttribute(character, "Skill." + skillName + ".party"))
	{
		skillPoints = sti(character.Skill.(skillName).party);
	}
	else
	{
		skillPoints = CalcPartySkill(character, skillName);
	}
	return skillPoints;
}

int CalcPartySkill(ref character, string skillName)
{
	int skillPoints = CalcCharacterSkill(character, skillName); // Captain can use ALL skills
	if(skillName != SKILL_FENCING) // Aconcagua: Fencing is a personal skill...
	{
		int i, cn, charSkill;
		if(IsMainCharacter(character))
		{
			int num = GetPassengersQuantity(character);
			for(i = 0; i < num; i++)
			{
				cn = GetPassenger(character, i);
				if(cn < 0)													continue;
				ref chr = GetCharacter(cn);
				if(CheckAttribute(chr, "prisoned") || IsCompanion(chr))		continue;
	
				charSkill = GetEffectiveSkill(chr, skillName);
				if(charSkill > skillPoints)	skillPoints = charSkill;
			}
		}
		else
		{
			if (IsCompanion(character))
			{
				for(i = 1; i < 4; i++)
				{
					cn = GetOfficersIndex(&character,i);
					if(cn >= 0)
					{
						charSkill = GetEffectiveSkill(GetCharacter(cn), skillName);
						if(charSkill > skillPoints)	skillPoints = charSkill;
					}
				}
			}
		}
	}
	character.Skill.(skillName).party = skillPoints;
	return skillPoints;
}

int GetShipSkill(ref character, string skillName)
{
	if (skillName == SKILL_LEADERSHIP || skillName == SKILL_SAILING)
	{
		bool ResetSkills = GetCharacterShipClass(character) != sti(GetAttribute(character, "skill." + skillName + ".shipclass"));
		ResetSkills = ResetSkills || GetCompanionQuantity (character) != sti(GetAttribute(character, "skill." + skillName + ".fleetsize"));
		if (ResetSkills) ResetShipSkill(character, skillName);
	}

	int skillPoints = 0;
	if (CheckAttribute(character, "Skill." + skillName + ".ship"))
	{
		skillPoints = sti(character.Skill.(skillName).ship);
	}
	else
	{
		skillPoints = CalcShipSkill(character, skillName);
	}
	return skillPoints;
}

int CalcShipSkill(ref character, string skillName)
{
	int skillPoints = GetPartySkill(character, skillName);
	int shipclass   = GetCharacterShipClass(character);
	if(EnableLimitedShipClass() && skillPoints > 1 && shipclass > 0)
	{
		if(skillName == SKILL_LEADERSHIP || skillName == SKILL_SAILING)
		{
			if (shipclass < 6)
			{
				int dclass = shipclass - GetShipMinClassForCharacter(character);
				if (dclass < 0)
				{
					skillPoints += dclass;
				}
			}
			if (IsMainCharacter(character))
			{
				if (GetPartySkill(character, SKILL_LEADERSHIP) < FLEETCOMMAND_MIN_LEVEL && CheckFleetShips(false))
				{
					skillPoints--;
				}
			}
		}
	}

	if(skillPoints < 1)	skillPoints = 1;
	character.Skill.(skillName).ship        = skillPoints;
	character.skill.(skillName).shipclass   = shipclass;
	character.skill.(skillName).fleetsize   = GetCompanionQuantity (character);
	return skillPoints;
}

//=====================================================
//  Skill Modifier Functions
//=====================================================

// Set skill modifier from items
int CalcSkillModifier(ref character, string skillName)
{
	int j, qty;
	int mod = 0;
	ref itm;

	int iChrCabin = FindCharacterShipCabin(character); // KK
	for(j = 0; j < SKILLITEMS_QUANTITY; j++)
	{
		itm = &Items[NativeFindCharacter(&Items, SkillItems[j].id)];
		if(!CheckAttribute(itm, "skill." + skillName))
			continue;
// KK -->

		string itmid = itm.id;
		qty = GetCharacterItem(character, itmid);

		if (iChrCabin >= 0 && CheckAttribute(&Locations[iChrCabin], "box1.items." + itmid) == true)
			qty += sti(Locations[iChrCabin].box1.items.(itmid));
// <-- KK
		if( qty >= sti(itm.skill.num)) // *.skill.num = num required for effect. Default = 1
		{
			if(CheckAttribute(itm, "groupID") && IsCanEquiping(character, itm.groupID) && !IsEquipCharacterByItem(character, itmid))
				continue; // if equipable and not equipped, skip // KK

			// *.stack = num of item that can be stacked together. Default = 1
			if(sti(itm.skill.stack) >= qty/sti(itm.skill.num))
			{
				mod += sti(itm.skill.(skillName)) * qty/sti(itm.skill.num);
			}
			else
			{
				mod += sti(itm.skill.(skillName)) * sti(itm.skill.stack) / sti(itm.skill.num);
			}
		}
	}
	mod = iclamp(-MAX_SKILL_INCREASE, MAX_SKILL_INCREASE, mod); // PB: Single line
	character.skill.(skillName).modifier = mod;
	return mod;
}

// Reset item skill modifier
// Called when receiving/losing a skill item through TakeNItems
void ResetSkillModifier(ref character, string skillName)
{
	DeleteAttribute(character, "skill." + skillName + ".modifier");
	ResetEffectiveSkill(character, skillName);
}

void ResetSkillModifierAll(ref character)
{
	for(int i = 0; i < 10; i++)
	{
		if(DEBUG_EXPERIENCE>1) trace("XP LOG: Reset skill modifier "+GetSkillName(i));
		ResetSkillModifier(character, GetSkillName(i));
	}
}

//=====================================================
//  Skill Bonus Functions
//=====================================================

void SetUpCharacterBonus(ref chr)
{
	//First we determine how many bonus skills this character will have.
	int numbonus = 0;
	int val = rand(100);
	int numprefer = 0;
	aref Bonus, Prefer;
	string skillname;
	if(val < NPC_ONE_BONUS_CHANCE) numbonus = 1;
	if(val < (NPC_ONE_BONUS_CHANCE+NPC_TWO_BONUS_CHANCE)) numbonus = 2;
	if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Setup Bonusses for: "+GetMySimpleName(chr)+" with "+numbonus+" bonusses");
	for(int n = 0; n < numbonus; n++)
	{
		bool isset = false;
		if(CheckAttribute(chr,"nation"))
		{
			string nation = chr.nation;
			makearef(Bonus,SkillBonus.(nation));
			numprefer = GetAttributesNum(Bonus);
			int index = 0;
			int offset = rand(numprefer-1);
			for(int i = 0; i < numprefer; i++)
			{
				if(!isset)
				{
					index = i+offset;
					if(index>=numprefer) index -= numprefer;
					Prefer = GetAttributeN(Bonus,i);
					val = rand(100);
					if(val < sti(Prefer))
					{
						skillname = GetAttributeName(Prefer);
						if(stf(GetAttribute(chr,"skill."+skillname+".bonus")) > 1.0) continue;
						if(DEBUG_EXPERIENCE>1) trace("XP LOG: Picked "+skillname);
						chr.skill.(skillname).bonus = 1.25;
						isset = true;
					}
				}
			}
		}
		if(!isset)
		{
			skillname = GetSkillName(rand(9));
			if(DEBUG_EXPERIENCE>1) trace("XP LOG: Picked "+skillname);
			chr.skill.(skillname).bonus = 1.25;
			isset = true;
		}
	}
	chr.bonussetup = true;
}

//This function Inits the chances for bonusses
//Each nation has specific chances. The total of the values added together should be 100, as many skills can be added
void InitBonusChances()
{
	string nation = ENGLAND;
	string skill = SKILL_SAILING;
	SkillBonus.(nation).(skill) = 65;
	skill = SKILL_LEADERSHIP;
	SkillBonus.(nation).(skill) = 35;
	
	nation = FRANCE;
	skill = SKILL_DEFENCE;
	SkillBonus.(nation).(skill) = 75;
	skill = SKILL_REPAIR;
	SkillBonus.(nation).(skill) = 25;
	
	nation = SPAIN;
	skill = SKILL_SNEAK;
	SkillBonus.(nation).(skill) = 80;
	skill = SKILL_COMMERCE;
	SkillBonus.(nation).(skill) = 20;
	
	nation = PIRATE;
	skill = SKILL_FENCING;
	SkillBonus.(nation).(skill) = 50;
	skill = SKILL_GRAPPLING;
	SkillBonus.(nation).(skill) = 50;
	
	nation = HOLLAND;
	skill = SKILL_COMMERCE;
	SkillBonus.(nation).(skill) = 80;
	skill = SKILL_SAILING;
	SkillBonus.(nation).(skill) = 20;
	
	nation = PORTUGAL;
	skill = SKILL_ACCURACY;
	SkillBonus.(nation).(skill) = 50;
	skill = SKILL_CANNONS;
	SkillBonus.(nation).(skill) = 50;
	
	nation = AMERICA;
	skill = SKILL_REPAIR;
	SkillBonus.(nation).(skill) = 70;
	skill = SKILL_LEADERSHIP;
	SkillBonus.(nation).(skill) = 30;
}

//=====================================================
//  Skill Importance Functions
//=====================================================

void UpdateSkillImportance(ref chref, string expName, int skillExp)
{
	if(sti(chref.skill.(expName)) >= SKILL_MAX) return;
	//small bursts of experience will probably increase your importance more then one large burst.
	//At least thats what this function is aiming for.
	int nextSkill = makeint(CalculateSkillExperienceFromRank(sti(chref.skill.(expName))+1));
	//We want to know the percentage of experience we gathered for the nextskill
	//We take a random number from the skillExp to have randomization in it and favor small bursts
	float percentage = rand(skillExp) / nextSkill * 100;
	//if the percentage is over 50% we should increase the importance by default. so we multiply the percentage times 2
	//We take a random number from this percentage and see if we are lucky.
	int chance = makeint(percentage * 2);
	if(DEBUG_EXPERIENCE>1) Trace("XP LOG: chance of increasing importance: "+chance+" for skill: "+expName);
	if(rand(100)<chance)
	{
		//Very low importance should increase fast so you can level this skill easier.
		int importance = sti(chref.skill.(expName).importance);
		int inc = 0;
		if(importance < 25) inc = 3;
		if(importance < 50) inc = 1;
		if(importance < 75) inc = 2;
		if(importance < 75) inc = 3;
		chref.skill.(expName).importance = importance + inc;
		chref.skillimportancetotal = sti(chref.skillimportancetotal) + inc;
	}
	//We shouldn't add an max because when playing longer all the importances will grow. At one moment they will all be capped to the max then.
	//This way they would eventually all increase lineair.
}

//Adding skillpriorities to a character
void SetCharSkillImportance(ref chref, int SkillVariation)
{
	if(DEBUG_EXPERIENCE>1) Trace("XP LOG: add skill importance for character: "+GetMySimpleName(chref));
	//Check if there is an offictype assigned
	if(!CheckAttribute(chref,"quest.officertype"))
	{
		chref.quest.officertype = GetRandomNPCType();
		if(IsMainCharacter(chref)) chref.quest.officertype = OFFIC_TYPE_CIVILIAN;
		Trace("XP ERROR: No officertype assigned to: "+GetMySimpleName(chref)+" now set to: "+chref.quest.officertype);
	}
	string offictype = chref.quest.officertype;
	//Start the loop
	ref pchar = GetMainCharacter();
	//We use the skill list in maincharacter to loop trough so we know its always accurate
	aref skills; makearef(skills,pchar.skill);
	string skill;
	int importance = 0;
	int numskills = GetAttributesNum(skills);
	int total = 0;
	for(int n = 0; n < numskills; n++)
	{
		skill = GetAttributeName(GetAttributeN(skills, n));
		if(skill == "freeskill") continue;
		//Check if a level has been set already
		if(!CheckAttribute(chref,"skill."+skill)) chref.skill.(skill) = 1;
		//Get the importance for the skill
		if(CheckAttribute(OfficerTypes,offictype+".skills."+skill+".importance"))
		{
			importance = sti(OfficerTypes.(offictype).skills.(skill).importance)*IMPORTANCE_BOOST+rand(SkillVariation*10);
		}
		else
		{
			if(DEBUG_EXPERIENCE>1) Trace("XP LOG: No importance assiged to: "+skill+" for offictype: "+offictype+" so use default");
			importance = 1+rand(15)+rand(SkillVariation*10);
		}
		//When we have a bonus for the skill increase importance
		if(CheckAttribute(chref,"skill."+skill+".bonus")) 
		{
			if(stf(chref.skill.(skill).bonus) > 1)
			{
				importance += IMPORTANCE_BONUS_GAIN+rand(SkillVariation*10);
				if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Bonus found so importance increased");
			}
		}
		//If the level is higher the 1 for this skill it should also get extra importance
		if(sti(chref.skill.(skill)) > 1)
		{
			importance += IMPORTANCE_SKILL_GAIN*sti(chref.skill.(skill));
			if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Character has level in skill so add importance");
		}
		if(DEBUG_EXPERIENCE>1) Trace("XP LOG:  Set skill "+skill+" to importance: "+importance+" for "+GetMySimpleName(chref));
		//Set the importance
		chref.skill.(skill).importance = importance;
		total += importance;
		//Set experience for skill in case it isn't set yet
		if(!CheckAttribute(chref,"Experience."+skill)) chref.Experience.(skill) = 0;
	}
	//Set this so we know when it's set for someone.
	chref.skillimportancetotal = total;
	chref.skillsetup = chref.quest.officerType;
}

//=====================================================
//  Perk Functions
//=====================================================

void PrepareSelectPerksForCharacter(ref chref)
{
	if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: Prepare SelectPerksForCharacter for: "+GetMySimpleName(chref));
	//Let's check the different perktypes and see what our character can pick
	//We use the skill list in maincharacter to loop trough so we know its always accurate
	int numperktypes = GetAttributesNum(PerkTypes);
	aref perktype;
	int total = 0;
	int numskills = 0;
	int weight = 0;
	int sumskill = 0;
	int highest = -1;
	int hval = 0;
	string skillname, typename;
	for(int n = 0; n < numperktypes; n++)
	{
		typename = GetAttributeName(GetAttributeN(PerkTypes, n));
		makearef(perktype,PerkTypes.(typename).Skill);
		//A perktype has serveral contributing skills. They are weighted and when added together with theire
		//weighting they can be max 100. We use this number to determine which skilltype will be picked.
		sumskill = 0;
		if(!CheckAttribute(chref,"PerkTypes."+typename+".maxed")) //If we have all perks already it will have no weight anymore.
		{
			numskills = GetAttributesNum(perktype);
			for(int i = 0; i < numskills; i++)
			{
				weight = sti(GetAttributeValue(GetAttributeN(perktype, i)));
				skillname = GetAttributeName(GetAttributeN(perktype, i));
				sumskill += weight*sti(chref.skill.(skillname))
			}
		}
		chref.PerkTypes.(typename) = sumskill;
		if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: Perktype: "+typename+" has a score of: "+sumskill);
		total += sumskill;
		if(sumskill > hval) {highest = n; hval=sumskill;}
	}
	if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: There is a total of: "+total);
	chref.PerkTypes = total;
	chref.PerkTypes.highest = highest;
}

bool SelectPerksForCharacter(ref chref, int attempts)
{
	if(sti(chref.PerkTypes) <= 0) return false;
	string typename;
	int numperktypes = GetAttributesNum(PerkTypes);
	if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: Called SelectPerksForCharacter for: "+GetMySimpleName(chref));
	string offictype = chref.quest.officertype;
	//First we try to add a perk to the highest PerkType
	typename = GetAttributeName(GetAttributeN(PerkTypes, sti(chref.PerkTypes.highest)));
	if(SelectPerkForType(typename, chref))
	{
		return true;
	}
	else
	{
		//Let's try again a few more times and see if we can find a nice perk.
		int rnum = 0;
		for(int n = 0; n < attempts; n++)
		{
			if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: attempt "+(n+2)+" to find a perk");
			//Let's find a random perktype. By taking a random of the total and checking it agains the weights we should still
			//Take the character into account
			rnum = rand(sti(chref.PerkTypes));
			if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: attempt "+(n+2)+" random number: "+rnum);
			for(int i = 0; i < numperktypes; i++)
			{
				typename = GetAttributeName(GetAttributeN(PerkTypes, i));
				if(rnum < sti(chref.PerkTypes.(typename)))
				{
					if(SelectPerkForType(typename, chref)) 
					{
						return true;
					}
					break;
				}
				else
				{
					rnum -= sti(chref.PerkTypes.(typename));
				}
			}
		}
	}
	return false;
}

bool SelectPerkForType(string type, ref chref)
{
	if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: called SelectPerkForType for type: "+type);
	aref perks; makearef(perks,PerkTypes.(type).Perks);
	//Let's loop trough the perks and see if there is any we can assign.
	int numperks = GetAttributesNum(perks);
	string perkname;
	string offictype = chref.quest.officertype;
	if(type == PERK_TYPE_COMBAT) offictype = "Combat";
	int score = 0;
	int highest = -1;
	int hval = 0;
	bool lockedperks = false;
	bool nonassignable = false;
	for(int n = 0; n < numperks; n++)
	{
		perkname = GetAttributeName(GetAttributeN(perks, n));
		//We keep an score for each perk, the better the score the higher the chance it will be chose.
		if(isPerkAssignableOfficer(chref, perkname, sti(chref.perks.FreePoints)))
		{
			//A higher cost means a more interesting perk normally so if we can affort it we should take it.
			score = sti(perks.(perkname));
			//Let's check if its a contributing perk
			if(CheckAttribute(OfficerTypes,offictype+".noncontribchance"))
			{
				if(rand(100) < sti(OfficerTypes.(offictype).noncontribchance))
				{
					//The perk is allowed to be scored. Now let's see if it's an actual assigned perk for this officertype. If so we give it 1 bonus.
					if(CheckAttribute(OfficerTypes,offictype+".perks."+perkname))
					{
						score += 1;
					}
				}
			}
			else
			{
				//If there is no noncontribchance then if the perk isn't set for the offictype we wont look at it.
				if(!CheckAttribute(OfficerTypes,offictype+".perks."+perkname))
				{
					continue;
				}
			}
			//Check if the main character has the perk already unlocked
			if(CheckCharacterPerkLocked(chref, perkname))
			{
				//If the perk is locked there is a chance this will be unlocked. At level 25 all will be unlocked
				if(rand(50)<pow(sti(chref.rank),1.2))
				{
					//If the perk is unlocked this is good so we add something to the score
					score += 1;
				}
				lockedperks = true;
			}
			if(CheckAttribute(perks,perkname+".rank"))
			{
				if(sti(chref.rank) >= sti(perks.(perkname).rank))
				{
					//We passed the required rank for this perk so that makes it more important
					score += 1;
				}
			}
			if(CheckAttribute(perks,perkname+".unlocks"))
			{
				//This perk unlocks new perks so that makes it extra important
				score += 2;
			}
			if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: Perk: "+perkname+" is avaible and has a score of: "+score);
			if(score > highest){ highest = n; hval = score;}
		}
		else
		{
			if(DEBUG_PERKSELECT>1) trace("PERK SELECT: Perk: "+perkname+" is non assignable");
			nonassignable = true;
		}
	}
	if(score == 0 && !lockedperks && !nonassignable)
	{
		if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: Perktype "+type+" is maxed out so run prepare again");
		chref.PerkTypes.(type).maxed = true;
		PrepareSelectPerksForCharacter(chref); //Run the prepare again so the new weights are calculated.
		return false;
	}
	if(highest >= 0)
	{
		int chance = 100;
		if(hval <2) chance -= 40; //If the score is only 1 we have a 50% chance of taking this perk. There might be something better or we should wait till something with more points comes along
		if(sti(chref.rank) < 10) chance -= 25; //If we are below level 10 we should have a large chance of skipping a perk because there is a large chance something better is out there.
		if(sti(chref.rank) < 20) chance -= 15; //If we are below level 20 we should have a chance of skipping a perk because there is a large chance something better is out there.
		if(type != GetAttributeName(GetAttributeN(PerkTypes, sti(chref.PerkTypes.highest)))) chance -= 35; //If this isn't the best PerkType we should have less chance of picking one.
		if(rand(100)<chance)
		{
			perkname = GetAttributeName(GetAttributeN(perks, highest));
			if(CheckCharacterPerkLocked(chref, perkname))
			{
				UnlockPerkCharacter(chref, perkname); 
				if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: Unlocked perk: "+perkname+" for: "+GetMySimpleName(chref));
			}
			chref.perks.list.(perkname) = 1;
			chref.perks.FreePoints = sti(chref.perks.FreePoints) - GetPerkCost(perkname);
			DeleteAttribute(chref,"ContribList");
			if(DEBUG_PERKSELECT>1) Trace("PERK SELECT: Assigned perk: "+perkname+" to: "+GetMySimpleName(chref));
			return true;
		}
	}
	return false;
}

//=====================================================
//  Character Functions
//=====================================================

//This function will set up a complete character with everything set
void InitCharacterSkills(ref chref)
{
	if(DEBUG_EXPERIENCE>1) Trace("XP LOG: Start InitCharacterSkills for " + GetMySimpleName(chref));
	CheckCharacterSetup(chref); //First check if everything is there.
	int rank = sti(chref.rank);
	int skillrank = 1;
	if(!CheckAttribute(chref,"assignrank"))
	{
		SetCharSkillImportance(chref, 1); //Setup the importance
		skillrank = ResetSkillsandPerks(chref);
		if (!CheckAttribute(chref,"bonussetup")) SetUpCharacterBonus(chref); //Setup the bonus
		if(DEBUG_EXPERIENCE>1)trace("XP LOG: Rank Check "+GetMySimpleName(chref)+" rank: "+rank+" skillrank: "+skillrank);
		if(skillrank > rank && !CheckAttribute(chref,"IsFantom")) rank = skillrank; //Fantoms keep their assigned rank so they get the XP they need.
		if(rank < 5) rank = GetRandomRank(CharacterIsFriend(chref), chref.quest.officerType, 0); //We don't like level 1 characters that much
		if(DEBUG_POSTINIT > 1)Trace("POSTINIT: rank "+rank);
	}
	else
	{
		rank = sti(chref.assignrank);
		if(DEBUG_POSTINIT > 1)Trace("POSTINIT: assigned rank "+rank);
	}
	if(rank>1)
	{
		if(CheckAttribute(chref,"questchar"))
		{
			if(DEBUG_POSTINIT > 1)Trace("POSTINIT: quest char");
			//Questchars always use skillrank
			chref.rank = skillrank;
			chref.Experience = CalculateExperienceFromRank(skillrank);
			//Let's give them some perks
			chref.perks.FreePoints =  skillrank * ADD_ABILITYPOINTS_PERLEVEL;
			PrepareSelectPerksForCharacter(chref);
			for(int n = 0; n < skillrank; n++)
			{
				SelectPerksForCharacter(chref, rand(1));
			}
			FinishCharInit(chref);
		}
		else
		{
			bool dopost = false;
			if(AllowCharacterPostInit() && rank < POSTINIT_MAX_ALLOW_LEVEL_POST)
			{
				dopost = true;
			}
			if(dopost) dopost = AddToPostInitQueue(chref, rank);
			if(!dopost)
			{
				if(DEBUG_POSTINIT > 1)Trace("POSTINIT: do normal init");
				AddXPtoChar(chref, "", CalculateExperienceFromRank(rank)); //Bypassing multipliers and shared experience
				FinishCharInit(chref);
			}
		}
	}
}

//This function finishes the character setup process
void FinishCharInit(ref chr)
{
	if(DEBUG_EXPERIENCE>1 || DEBUG_POSTINIT > 1) trace("XP LOG: Finish character init for " + GetMySimpleName(chr));
	//Try to select another perk to compensate for the lack of try during init
	if(PostInitActive)
	{
		string eventname = "SelectPerks"+chr.id+chr.rank;
		SetEventHandler(eventname,"procSelectPerksForCharacter",1);
		PostEvent(eventname,0,"ils",chr,2,chr.location);
	}
	else
	{
		SelectPerksForCharacter(chr, 2);
	}
	//Set the skills right
	ResetSkillModifierAll(chr); // PB: was ResetEffectiveSkillAll
	//Set the HP right
	ResetHP(chr); // PB: was ResetMaxHP
	//Equip things if not done yet
	ExecuteCharacterEquip(chr);
	chr.completeinit = true;
}

//This function checks all kinds of things in the character and if it isn't right it will set it up.
//TODO: Merge this with an other check function which is called earlier in the process (during create character)
void CheckCharacterSetup(ref chref)
{
	if (!CheckAttribute(chref,"id")) {chref.id = "without_id"; }
	if (!CheckAttribute(chref,"Experience")) {chref.Experience = 1; }
	if (!CheckAttribute(chref,"perks.FreePoints")){chref.perks.FreePoints = 1; } 
	if (!CheckAttribute(chref,"skill.freeskill")){chref.skill.freeskill = 0; } 
	if (!CheckAttribute(chref,"quest.officertype") || GetAttribute(chref,"quest.officertype") == "combat")
	{
		if(GetAttribute(chref,"isOfficer") == 1)
		{
			chref.quest.officertype = GetRandomOfficerType();
		}
		else
		{
			if(GetAttribute(chref,"issoldier") == 1)
			{
				chref.quest.officertype = OFFIC_TYPE_GUARD;
			}
			else
			{
				if(GetAttribute(chref,"isMerchant") == 1)
				{
					chref.quest.officertype = OFFIC_TYPE_SHOPKEEPER;
				}
				else
				{
					if(GetAttribute(chref,"isWarrior") == 1)
					{
						chref.quest.officertype = GetRandomEnemyType();
					}
					else
					{
						chref.quest.officerType = GetRandomNPCType();
					}
				}
			}
		}
	}
	if (CharacterHasShip(chref)) chref.quest.officerType = GetCaptainType(chref);
	if (!CheckAttribute(chref,"rank")) {chref.rank = 1; }
	if (!CheckAttribute(chref,"quest.officerprice") && !IsMainCharacter(chref)) chref.quest.officerprice = 0;
	if (!CheckAttribute(chref,"Money")) {
        chref.Money = GetRandCharMoney(chref, makeint(Rand(15)+10));
    } else {
        if (sti(chref.Money) == 0) chref.Money = GetRandCharMoney(chref, makeint(Rand(15)+10));
    }
	//Checks for leaving officers
	if (!CheckAttribute(chref,"loyality")) {chref.loyality = 5+rand(15); }
	if (!CheckAttribute(chref,"alignment")) {if(rand(1)==1){chref.alignment = "good";}else{chref.alignment = "bad";}}
	if (!CheckAttribute(chref,"homelocation")) 
	{
		if(loadedLocation.type == "tavern")
		{
			chref.homelocation = "";
			chref.homelocation.group = "";
			chref.homelocation.locator = "";
			chref.homestate = "";
		}
		else
		{
			chref.homelocation = chref.location; // PB: was alignment???
			chref.homelocation.group = chref.location.group;
			chref.homelocation.locator = chref.location.locator;
			if(CheckAttribute(chref,"chr_ai.type")) chref.homestate = chref.chr_ai.type;
			else chref.homestate = "citizen";
		}
	}
	if(CheckAttribute(chref,"Ship")) SetBaseShipData(chref);
}

int ResetSkillsandPerks(ref chref)
{
	//Reset the Character to level 1
	if(DEBUG_EXPERIENCE>1) trace("XP LOG: Character "+GetMySimpleName(chref)+" has been reset to 0"); //Show these always
	aref skills; makearef(skills,chref.skill);
	string skill;
	int numskills = GetAttributesNum(skills);
	int skillrank = 0;
	for(int n = 0; n < numskills; n++)
	{
		skill = GetAttributeName(GetAttributeN(skills, n));
		if(skill == "freeskill") continue;
		skillrank += (sti(chref.skill.(skill))-1);
		if(!CheckAttribute(chref,"questchar")) //Don't reset skills for questchars
		{
			chref.skill.(skill) = 1;
			chref.skill.(skill).bonus = 1.0;
		}
		if(sti(chref.skill.(skill)) < 1)
		{
			//This character should have this skill on 0 so we do this by using the charmod
			chref.skill.(skill) = 1;
			chref.skill.(skill).charmod = -10;
		}
	}
	chref.perks.FreePoints = 1;
	chref.skill.freeskill = 0;
	chref.Experience = 0;
	ResetHP(chref);
	DeleteAttribute(chref,"perks");
	DeleteAttribute(chref,"ContribList");
	chref.rank = 1;
	return makeint(skillrank/ADD_SKILLPOINTS_PERLEVEL);
}

//=====================================================
//  HP Functions
//=====================================================

float ResetHP(ref chr)
{
	if(CheckAttribute(chr,"old.chr_ai.hp"))
	{
		DeleteAttribute(chr,"old.chr_ai.hp");
		DeleteAttribute(chr,"old.chr_ai.hp_max");
	}
	ResetMaxHP(chr);
	float HP = stf(chr.chr_ai.hp_max);
	chr.chr_ai.hp = HP;
	return HP;
}

float ResetMaxHP(ref chr)
{
	float HP = CHAR_START_HITPOINTS;
	if(!CheckAttribute(chr,"old.chr_ai.hp"))
	{
		//First let's save the percentage of HP we have at the moment.
		float HPper = 1;
		if(CheckAttribute(chr,"chr_ai.hp") && CheckAttribute(chr,"chr_ai.hp_max")) HPper = stf(chr.chr_ai.hp)/stf(chr.chr_ai.hp_max);
		int type = 0;
		int PlayerHPperLevel = CHAR_HITPOINTS_PER_LEVEL;
		float level = makefloat(GetLevel(&chr));
		if(!CheckAttribute(chr,"FakeLevels")) chr.FakeLevels = 0; //Levis
		level = level + sti(chr.FakeLevels); //Levis
		if(CheckAttribute(chr, "HPBonus")) HP += stf(chr.HPBonus);
		HP += GetHPBaseBonusOT(chr);
		//For now friendly and not friendly are the same, might change later.
		if(CharacterIsFriend(chr))
		{
			//Friendly
			PlayerHPperLevel = (PlayerHPperLevel+1)-GetDifficulty()+GetHPLevelBonusOT(chr);
		}
		else
		{
			//Not Friendly
			PlayerHPperLevel = (PlayerHPperLevel)-(4-GetDifficulty())+GetHPLevelBonusOT(chr);
		}
		HP += (level-1) * PlayerHPperLevel;
		if(IsCharacterPerkOn(chr, "Toughness"))
		{
			HP = HP * 1.1;			// 10% health bonus for the tough guys
			chr.chr_ai.hp_dlt = LAI_DEFAULT_DLTHP * TOUGHNESS_REGEN_MULT; // higher regeneration rate, default is 0.1 - LDH 14Apr09
		}
		chr.chr_ai.hp_max = HP;
		//Apply the percentage again to the new HP (if we have any change)
		chr.chr_ai.hp = HP * HPper;
	}
	else
	{
		HP = stf(chr.chr_ai.hp_max);
	}
	return HP;
}

int ChangeHPBonus(ref chr, int offset)
{
	if(CheckAttribute(chr, "HPBonus")) offset += sti(chr.HPBonus);
	chr.HPBonus = offset;
	return sti(offset);
}

//=====================================================
//  POST-INIT Functions
//=====================================================

//All characters are first added to a queue, from there they are processed in runtime. This functions adds the character to a layer. The higher the layer the later the character will be processed
bool AddToPostInitQueue(ref chr, int rank)
{
	if(DEBUG_POSTINIT > 1)Trace("POSTINIT: try to add "+GetMySimpleName(chr)+" to queue with rank "+rank);
	if(GetAttribute(PostInitQueue,"active")==true) StopPostInitChars();
	float x,y,z,gx,gy,gz,dist;
	GetCharacterPos(GetMainCharacter(),&x,&y,&z);
	GetCharacterPos(chr,&gx,&gy,&gz);
	string idx = chr.index;
	dist = sqrt(sqr(x - gx) + sqr(y - gy) + sqr(z - gz));
	//For each 20 we make a new layer.
	int layer = makeint(dist/10.0);
	if(layer == 0)
	{
		if(DEBUG_POSTINIT > 1)Trace("POSTINIT: character too close, do normal init ");
		return false;
	}
	else
	{
		chr.assignrank = rank; //store the rank in the character in case it isn't completly processed before exiting the location
		string layername = "layer"+layer;
		PostInitQueue.Characters.list.(layername).(idx).distance = dist;
		PostInitQueue.Characters.list.(layername).(idx).rank = rank;
		PostInitQueue.Characters.amount = GetAmountInPostInitQueue() + 1;
		if(sti(GetAttribute(PostInitQueue,"MaxLayer")) < layer) PostInitQueue.MaxLayer = layer;
		if(DEBUG_POSTINIT > 1)Trace("POSTINIT: added to queue");		
	}
	return true;
}

int GetAmountInPostInitQueue()
{
	if(!CheckAttribute(PostInitQueue,"Characters.amount")) return 0;
	return sti(PostInitQueue.Characters.amount);
}

void StartPostInitChars()
{
	if(DEBUG_POSTINIT > 1)Trace("POSTINIT: start post init event");
	PostInitQueue.active = true;
	PostInitQueue.active.layer = 0;
	PostInitQueue.active.character = 0;
	PostInitQueue.active.piece = 0;
	PostEvent("PostInitChars",1000);
	PostInitActive = true;
}

void PostInitChars()
{
	if(DEBUG_POSTINIT > 1)Trace("POSTINIT: eventcall"); 
	if(GetAttribute(PostInitQueue,"active")==true)
	{
		int curlayer = sti(PostInitQueue.active.layer);
		int curchr = sti(PostInitQueue.active.character);
		int curpiece = sti(PostInitQueue.active.piece);
		string curlayername = "layer"+curlayer;
		aref layer; makearef(layer,PostInitQueue.Characters.list.(curlayername));
		if(GetAttributesNum(layer) > 0 && GetAttributesNum(layer) > sti(PostInitQueue.active.character))
		{
			aref Character = GetAttributeN(layer,curchr);
			ref chr = GetCharacter(sti(GetAttributeName(Character)));
			if(DEBUG_POSTINIT > 1)Trace("POSTINIT: character "+GetMySimpleName(chr)+" id "+chr.id); 
			if(!CheckAttribute(chr,"rank"))
			{
				CheckCharacterSetup(chr); //This shouldn't happen but it seems somewhere between adding it to post init and doing it the rank gets removed sometimes???
				trace("XP ERROR: Character "+GetMySimpleName(chr)+" was missing rank during post init");
				DumpAttributes(chr);
			}
			if(sti(GetAttribute(Character,"rank"))>0)
			{
				int addlevel = POSTINIT_AMOUNT_LEVELS;
				if(addlevel > sti(Character.rank)) addlevel = sti(Character.rank);
				int exp = makeint((CalculateExperienceFromRank(sti(chr.rank)+addlevel) - sti(chr.experience))/(POSTINIT_AMOUNT_PIECES-curpiece));
				if(AddXPtoChar(chr, "", exp))
				{
					Character.rank = sti(Character.rank)-addlevel;
					PostInitQueue.active.piece = 0;
				}
				else
				{
					PostInitQueue.active.piece = curpiece + 1;
				}
			}
			else
			{
				FinishCharInit(chr);
				PostInitQueue.active.character = curchr + 1;
			}
		}
		else
		{
			if(DEBUG_POSTINIT > 1)TraceandLog("POSTINIT: Layer "+curlayer+" finished!"); 
			PostInitQueue.active.layer = curlayer+1;
			PostInitQueue.active.character = 0;
			if((curlayer+1) > sti(GetAttribute(PostInitQueue,"MaxLayer")))
			{
				if(DEBUG_POSTINIT > 1)Trace("POSTINIT: reached max layer"); 
				StopPostInitChars();
			}
		}
		PostEvent("PostInitChars",1);
	}
}

void StopPostInitChars()
{
	if(DEBUG_POSTINIT > 1)TraceandLog("POSTINIT: Stop postinit event"); 
	PostInitQueue.active = false;
	PostInitQueue.MaxLayer = 0;
	PostInitQueue.Characters.amount = 0;
	aref Characters; makearef(Characters,PostInitQueue.Characters);
	DeleteAttribute(Characters,"list");
	if(DEBUG_POSTINIT>1) DumpAttributes(PostInitQueue);
	PostInitActive = false;
}

//This returns if post init is allowed or not
bool AllowCharacterPostInit()
{
	if(LAi_IsBoardingProcess()) return false;
	if(GetAttribute(PostInitQueue,"allowed") == false) return false;
	return true;
}

//Use this to enable the use of post init when a character is created
void SetCharacterPostInit(bool state)
{
	if(DEBUG_POSTINIT > 1)Trace("POSTINIT: state is "+state);
	PostInitQueue.allowed = state;
}

void procAddXPtoSkillsMain()
{
	//Event to call the function in post init to speed things up
	aref chref = GetEventData();
	string expName = GetEventData();
	int skillExp = GetEventData();
	string location = GetEventData();
	ref pchar = GetMainCharacter();
	if(location != pchar.location) return; //Check if we left the location but the event wasn't done yet.
	if(!IsEntity(chref)) return; //Check if for some reason it was deleted already
	if(DEBUG_EXPERIENCE > 0)trace("XP LOG: Event for skills triggered for "+GetMySimpleName(chref));
	DelEventHandler("AddXPtoSkills"+chref.id+chref.Experience,"procAddXPtoSkillsMain");
	AddXPtoSkillsMain(chref, expName, skillExp)
}

void procSelectPerksForCharacter()
{
	//Event to call the function in post init to speed things up
	aref chref = GetEventData();
	int attempts = GetEventData();
	string location = GetEventData();
	ref pchar = GetMainCharacter();
	if(location != pchar.id) return; //Check if we left the location but the event wasn't done yet.
	if(!IsEntity(chref)) return; //Check if for some reason it was deleted already
	if(DEBUG_PERKSELECT > 0)trace("PERK SELECT: Event triggered for "+GetMySimpleName(chref));
	DelEventHandler("SelectPerks"+chref.id+chref.rank,"procSelectPerksForCharacter");
	SelectPerksForCharacter(chref, attempts)
}

//=====================================================
//  Calculate Functions
//=====================================================

int CalculateExperienceFromRank(int _Rank)
{
	if(_Rank < 1) return 0;
	return makeint(1200*pow((_Rank-1),2)+100*(_Rank-1)+800*pow(2.75,sqrt(_Rank-1)));
}

int CalculateSkillExperienceFromRank(int rank)
{
	//makeint(((CalculateExperienceFromRank(rank)-CalculateExperienceFromRank(rank-1))*SKILL_NEXT_XP_MULT) / ADD_SKILLPOINTS_PERLEVEL
	int maxexp = CalculateExperienceFromRank(makeint((10 * SKILL_MAX) / ADD_SKILLPOINTS_PERLEVEL)); //Take the XP needed for level all skillpoints are used
	//We got 10 skills each going to SKILL_MAX we need to know how !SKILL_MAX so use a forloop.
	int amskills = 0;
	for(int n = 1; n < SKILL_MAX; n++) {amskills += pow(n,2);}
	return makeint((maxexp/10) / amskills * pow((rank-1),2));
}

int GetTotalRank(ref chr)
{
	int charRank = sti(chr.rank);
	if(CheckAttribute(chr, "FakeLevels")) charRank += sti(chr.FakeLevels);
	return charRank;
}

//=====================================================
//  Lookup Functions
//=====================================================

//Get xp multiplier for different skills
float GetXPmult(string Skillname)
{
	float expMult = 1;
	switch (Skillname)
	{
		case "Leadership":	expMult =  3 ; break;
		case "Fencing":		expMult =  2   ; break;
		case "Sailing":		expMult =  1   ; break;
		case "Accuracy":	expMult =  1.5 ; break;
		case "Cannons":		expMult =  0.5 ; break;
		case "Repair":		expMult = 50   ; break;
		case "Defence":		expMult =  4   ; break;
		case "Sneak":		expMult =  2 ; break;
		case "Grappling":	expMult =  3   ; break;
		case "Commerce": 	expMult =  0.75; break;
	}
	return expMult*EXPERIENCE_MULTIPLIER;
}

// skill and expirence service
string GetSkillName(int _SkillType)
{
	switch(_SkillType)
	{
		case 0:		return SKILL_LEADERSHIP;	break;
		case 1:		return SKILL_FENCING;		break;
		case 2:		return SKILL_SAILING;		break;
		case 3:		return SKILL_ACCURACY;		break;
		case 4:		return SKILL_CANNONS;		break;
		case 5:		return SKILL_GRAPPLING;		break;
		case 6:		return SKILL_REPAIR;		break;
		case 7:		return SKILL_DEFENCE;		break;
		case 8:		return SKILL_COMMERCE;		break;
		case 9:		return SKILL_SNEAK;			break;
	}
	return "";
}